#!/bin/bash
# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( GAME-SERVERS.) ********************
PROCESS_NAMES=(
  cod2_lnxded
  cod2_lnxdedcr
  cod4_lnxded
  cod4_lnxdedcr
  hlds_linux
  srcds_linux
  BattalionServer
  Main
  ts3server
  murmurd
);

for pid in $(for executable in ${PROCESS_NAMES[@]}; do pgrep ${executable} ;done) ;do 
  chrt -ar -p 98 $pid
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( Gameserver.guard.) ****************
for pid in $(pgrep Gameserver.guar); do
  chrt -ar -p 50 $pid
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( Java.) ****************************
for pid in $(pgrep java); do
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( TOP.) *****************************
for pid in $(pidof top); do
  chrt -ar -p 54 $pid
  renice 0 -p $pid
done


# ------------------------------------------------------------------------------------------

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( NetWork.) *************************
for pid in $(ps ax | grep -E "\s+\[irq\/[0-9]+-eth[0-9]+(-.+|)\]$" | awk '{print $1}'); do
  chrt -ar -p 98 $pid
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( Soft-IRQ_D.) **********************
for pid in $(pgrep ksoftirqd); do
  chrt -ar -p 50 $pid
  renice -1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( Kworker.) *************************
PIDS=`ps ax | grep kworker | grep -v grep | sed -e "s/^ *//" -e "s/ .*$//"`
for p in $PIDS; do
  renice -20 -p $p 
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( WWW-DATA.) *************************
for pid in $(pgrep nginx); do
  chrt -ar -p 50 $pid
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( My_SQL_D.) ************************
for pid in $(pgrep mysqld); do
  chrt -ar -p 50 $pid
  renice 1 -p $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( DISK_SDA .) ***********************
for pid in $(pgrep jbd2); do
  chrt -af -p 50 $pid
done

# __________________________________________________________________________________________
# ****** Process Scheduling/Optimizer for RT KERNEL. - ( Swap_FILE.) ***********************
for pid in $(pgrep kswapd0); do
  chrt -af -p 64 $pid
  renice 0 -p $pid
done

